// FBWFCMD.cpp : Defines the entry point for the console application.
//
// Copyright (c) 2006-2010 SJJ Embedded Micro Solutions, LLC. All Rights Reserved
//
// Code is provided AS IS without any warranty
//
// Description: Command line application demonstrates how to implement
//				the FBWF APIs for several of the core functions.
//
//
#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "fbwfapi.h"
void DisplayHelp();

int main(int argc, char *argv[])
{
		WCHAR szDrive[20];
	WCHAR szPath[128];
	DWORD dwStatus;
	ULONG IscsEnabled = 0;
	ULONG IsnsEnabled = 0;
	CHAR *csResult;
	CHAR *nsResult;
	ULONG cacheThreshold = 64;
	

	printf("\nFBWFCMD - FBWF API Example\n");
	printf("Copyright (c) 2006 SJJ Embedded Micro Solutions LLC., All Rights Reserved\n\n");
	
	
	if 	((argc >= 2)) 
	{
		//----------------------------------------------
		// FbwfEnableFilter
		//Enable FBWF
		//----------------------------------------------
		if (strcmp(argv[1], "-enable")==0) {
			if(!FbwfEnableFilter()){
				printf("FBWF Enabled.  ");
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Enable Error");
			}
							
		}

		//----------------------------------------------
		//FbwfDisableFilter
		//Disable FBWF
		//----------------------------------------------
		if (strcmp(argv[1], "-disable")==0) {
			if(!FbwfDisableFilter()){
					printf("FBWF Disabled. ");
					printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Disable Error");
			}
		}

		//----------------------------------------------
		//FbwfIsFilterEnabled
		//Check to see if FBWF is enabled
		//----------------------------------------------
		if (strcmp(argv[1], "-fbwfstate")==0) {
			if(!FbwfIsFilterEnabled(&IscsEnabled, &IsnsEnabled )){
				if(IscsEnabled){

					csResult = "ENABLED";
				}
				else{
					csResult = "DISABLED";
				}
				if(IsnsEnabled){

					nsResult = "ENABLED";
				}
				else{
					nsResult = "DISABLED";
				}
				printf("FBWF is %s\n", csResult);
				printf("FBWF for the next session is %s\n", nsResult);
			}
			else{
				printf("State Error");
			}
		}
		
		//----------------------------------------------
		//FbwfEnableCompression
		//Enable FBWF Compression
		//----------------------------------------------
		if (strcmp(argv[1], "-enablecompression")==0) {
			if(!FbwfEnableCompression( )){
				printf("FBWF compression enabled. ");
					printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Enable Compression Error");
			}
		}

		//----------------------------------------------
		//FbwfDisableCompression
		//Disable FBWF Compression
		//----------------------------------------------
		if (strcmp(argv[1], "-disablecompression")==0) {
			if(!FbwfDisableCompression( )){
				printf("FBWF compression disabled. ");
					printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Disable Compression Error");
			}
		}

		//----------------------------------------------
		//FbwfEnableCachePreAllocation
		//Enable FBWF Cache PreAllocation
		//----------------------------------------------
		if (strcmp(argv[1], "-enablecache")==0) {
			if(!FbwfEnableCachePreAllocation( )){
				printf("FBWF Cache PreAllocation enabled. ");
					printf("Reboot system for change to take effect\n");
			}
			else{
				printf("EnableCachePreAllocation Error");
			}
		}

		//----------------------------------------------
		//FbwfDisableCachePreAllocation
		//Disable FBWF Cache PreAllocation
		//----------------------------------------------
		if (strcmp(argv[1], "-disablecache")==0) {
			if(!FbwfDisableCachePreAllocation( )){
				printf("FBWF Cache PreAllocation disabled. ");
					printf("Reboot system for change to take effect\n");
			}
			else{
				printf("DisableCachePreAllocation Error");
			}
		}

		//----------------------------------------------
		//FbwfProtectVolume
		//Add a volume to be protected by FBWF Cache
		//----------------------------------------------
		if (strcmp(argv[1], "-protectvolume")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			
			dwStatus=FbwfProtectVolume(szDrive );
			if(!dwStatus ){
				printf("Volume %s will be protected in the next session. ",argv[2]);
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Error %d \n", dwStatus);
				printf("FBWF must be enabled for the next session");
				DisplayHelp();
			}
		}

		//----------------------------------------------
		//FbwfUnprotectVolume
		//Remove a volume to be protected by FBWF Cache
		//----------------------------------------------
		if (strcmp(argv[1], "-unprotectvolume")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			
			dwStatus=FbwfUnprotectVolume(szDrive,0 );
			if(!dwStatus ){
				printf("Volume %s  will be unprotected in the next session. ", argv[2]);
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Error %d \n", dwStatus);
				
				DisplayHelp();
			}
		}

		//----------------------------------------------
		//FbwfIsCompressionEnabled
		//Check to see if FBWF Compression is enabled
		//----------------------------------------------
		if (strcmp(argv[1], "-fbwfcompression")==0) {
			if(!FbwfIsCompressionEnabled(&IscsEnabled, &IsnsEnabled )){
				if(IscsEnabled){

					csResult = "ENABLED";
				}
				else{
					csResult = "DISABLED";
				}
				if(IsnsEnabled){

					nsResult = "ENABLED";
				}
				else{
					nsResult = "DISABLED";
				}
				printf("FBWF compresspon is %s\n", csResult);
				printf("FBWF compression for the next session is %s\n", nsResult);
			}
			else{
				printf("Compression Error");
			}
		}
		//----------------------------------------------
		//FbwfIsCachePreAllocationEnabled
		//Check to see if FBWF Cache PreAllocation is enabled
		//----------------------------------------------
		if (strcmp(argv[1], "-fbwfprealloc")==0) {
			if(!FbwfIsCachePreAllocationEnabled(&IscsEnabled, &IsnsEnabled )){
				if(IscsEnabled){

					csResult = "ENABLED";
				}
				else{
					csResult = "DISABLED";
				}
				if(IsnsEnabled){

					nsResult = "ENABLED";
				}
				else{
					nsResult = "DISABLED";
				}
				printf("FBWF Cache PreAlloc is %s\n", csResult);
				printf("FBWF Cache PreAlloc for the next session is %s\n", nsResult);
			}
			else{
				printf("Cache PreAlloc Error");
			}
		}

		//----------------------------------------------
		//FbwfIsVolumeProtected
		//Check if FBWF is portecting a specific volume
		//----------------------------------------------
		if (strcmp(argv[1], "-volumestatus")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			
			dwStatus=FbwfIsVolumeProtected(szDrive,&IscsEnabled,&IsnsEnabled);
						
			if(!dwStatus ){
				if(IscsEnabled){

					csResult = "ENABLED";
				}
				else{
					csResult = "DISABLED";
				}
				if(IsnsEnabled){

					nsResult = "ENABLED";
				}
				else{
					nsResult = "DISABLED";
				}
				printf("Volume %s  protection is %s\n", argv[2],csResult);
				printf("Volume %s  protection for next session is %s\n", argv[2],nsResult);
			}
			else{
				printf("Error %d \n", dwStatus);
				
				DisplayHelp();
			}
		}


		//----------------------------------------------
		//FbwfSetCacheThreshold
		//Set the Cache threshold for FBWF
		//----------------------------------------------
		/*
		if (strcmp(argv[1], "-setcache")==0) {
			
			cacheThreshold = atoi(argv[2]);
						
			dwStatus=FbwfSetCacheThresholdEx((unsigned)cacheThreshold);

			if(!dwStatus ){
				printf("Cache Threshold set to %u\n ", cacheThreshold);
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Error %d \n", dwStatus);
				if(dwStatus = ERROR_INVALID_PARAMETER){
					printf("Error: Threshold must be between 16 to 1024\n");
				}
				DisplayHelp();
			}

		}
		*/

		

		//----------------------------------------------
		// FbwfAddExclusion
		// Add a file or path to the exclusion list
		//----------------------------------------------
		if (strcmp(argv[1], "-addex")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			mbstowcs(szPath, argv[3], 128);

			dwStatus=FbwfAddExclusion(szDrive,szPath);
			if(!dwStatus ){
				printf("%s on drive %s is now excluded.\n ",argv[3],argv[2]);
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Error %d \n", dwStatus);
				DisplayHelp();
			}
		}
		
		//----------------------------------------------
		//FbwfRemoveExclusion
		//Remove a file or path to the exclusion list
		//----------------------------------------------
		if (strcmp(argv[1], "-remex")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			mbstowcs(szPath, argv[3], 128);

			dwStatus=FbwfRemoveExclusion(szDrive,szPath);
			if(!dwStatus ){
				printf("%s on drive %s is now removed from exclusion.\n ",argv[3],argv[2]);
				printf("Reboot system for change to take effect\n");
			}
			else{
				printf("Error %d \n", dwStatus);
				DisplayHelp();
			}
		}
		
		//----------------------------------------------
		// FbwfCommitFile
		// Commit a file in cache to the disk
		//----------------------------------------------
		if (strcmp(argv[1], "-commit")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			mbstowcs(szPath, argv[3], 128);

			dwStatus=FbwfCommitFile(szDrive,szPath);
			if(!dwStatus ){
				printf("%s on drive %s has been committed to the disk.\n ",argv[3],argv[2]);
			}
			else{
				printf("Error %d \n", dwStatus);
				DisplayHelp();
			}
		}

		//----------------------------------------------
		//FbwfRestoreFile
		//Restore a file in cache from the version on the disk
		//----------------------------------------------
		if (strcmp(argv[1], "-restore")==0) {
			
			mbstowcs(szDrive, argv[2], 10);
			mbstowcs(szPath, argv[3], 128);

			dwStatus=FbwfRestoreFile(szDrive,szPath);
			if(!dwStatus ){
				printf("%s on drive %s has been restored from the disk.\n ",argv[3],argv[2]);
			}
			else{
				printf("Error %d \n", dwStatus);
				if(dwStatus = ERROR_ACCESS_DENIED){
					printf("Error: File not in cache\n");
				}
				if(dwStatus = ERROR_FILE_NOT_FOUND){
					printf("Error: File not found\n");
				}
				
			}
		}

		//----------------------------------------------
		// Display help
		//----------------------------------------------
		if ((strcmp(argv[1], "-?")==0) || (strcmp( argv[1],"-help")==0)) {
					
					DisplayHelp();
		}

	}
	else
	{
		// If the parameter conditions fails display help
		DisplayHelp();
		return 1;
	}
	return 0;
}

void DisplayHelp()
{
	printf("\nFBWFCMD <Option>\n");
	printf("-enable			Enable FBWF\n");
	printf("-disable		Disable FBWF\n");
	printf("-enablecompression         Enable Compression\n");
	printf("-disablecompression        Disable Compression\n");
	printf("-enablecache		Enable Cache PreAllocate\n");
	printf("-disablecache		Disable Cache PreAllocate \n");
	printf("-protectvolume <volume>	Protect a new volume\n");
    printf("-unprotectvolume <volume>	Unprotect a new volume\n");
	printf("-fbwfstate		Gets the filter status\n");
	printf("-fbwfcompression	Gets the compresstion status\n");
	printf("-fbwfprealloc		Gets the Cache PreAllocation status\n");
	printf("-volumestatus <volume>	Gets the volume status\n");
	//	printf("-setcache <cache size>	cache size must be between 16 and 1024\n");
	printf("-addex <drive> <file or path>	add a file or path to the exclusion list\n");
	printf("-remex <drive> <file or path>	remove a file or path to the exclusion list\n");
	printf("-commit <drive> <file or path>	commits a file in cache to the disk\n");
	printf("-restore <drive> <file or path>	restores a file in cache from the disk\n");
}